/*
 *	eZ80 Processor Module
 *	Brandon Wilson
 *	2015
 */

#ifndef EZ80HPP
#define EZ80HPP

#include "../idaidp.hpp"
#include "ins.hpp"

//Customization of cmd structure:
#define o_cond  o_idpspec0
#define Cond    reg

//Condition code types
enum opcond_t
{
  oc_nz,
  oc_z,
  oc_nc,
  oc_c,
  oc_po,
  oc_pe,
  oc_p,
  oc_m,
  oc_not
};

enum RegNo ENUM_SIZE(uint16)
{
 R_b = 0,
 R_c = 1,
 R_d = 2,
 R_e = 3,
 R_h = 4,
 R_l = 5,
 R_a = 7,
 R_bc = 8,
 R_de = 9,
 R_hl = 10,
 R_af = 11,
 R_sp = 12,
 R_ix = 13,
 R_iy = 14,
 R_af2 = 15,
 R_r = 16,
 R_i = 17,
 R_f = 18,
 R_xl = 19,
 R_xh = 20,
 R_yl = 21,
 R_yh = 22,
 R_ixl = 23,
 R_ixu = 24,
 R_iyl = 25,
 R_iyu = 26,
 R_bc2 = 27,
 R_de2 = 28,
 R_hl2 = 29,
 R_ix2 = 30,
 R_iy2 = 31,
 R_b2 = 32,
 R_c2 = 33,
 R_d2 = 34,
 R_e2 = 35,
 R_h2 = 36,
 R_l2 = 37,
 R_a2 = 38,
 R_MB = 39,
 R_vcs = 40,	//virtual code segment register
 R_vds = 41,	//virtual data segment register
 R_vt = 42		//virtual T segment register, for ADL mode switching
};

extern char device[];
extern char deviceparams[];

void idaapi ez80_segstart(ea_t ea);
void idaapi ez80_header(void);
void idaapi ez80_footer(void);

int   idaapi ana(void);
int   idaapi emu(void);
void  idaapi out(void);
bool  idaapi outop(op_t &op);

const char* z80_find_ioport(uval_t port);

#endif // EZ80HPP
